<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX Tutorials: vx_tutorial_graph_image_gradients.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
    </ul>
  </div>
<h1>vx_tutorial_graph_image_gradients.c</h1><a href="vx__tutorial__graph__image__gradients_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">*</span>
<a name="l00003"></a>00003 <span class="comment">* Copyright (c) 2017 Texas Instruments Incorporated</span>
<a name="l00004"></a>00004 <span class="comment">*</span>
<a name="l00005"></a>00005 <span class="comment">* All rights reserved not granted herein.</span>
<a name="l00006"></a>00006 <span class="comment">*</span>
<a name="l00007"></a>00007 <span class="comment">* Limited License.</span>
<a name="l00008"></a>00008 <span class="comment">*</span>
<a name="l00009"></a>00009 <span class="comment">* Texas Instruments Incorporated grants a world-wide, royalty-free, non-exclusive</span>
<a name="l00010"></a>00010 <span class="comment">* license under copyrights and patents it now or hereafter owns or controls to make,</span>
<a name="l00011"></a>00011 <span class="comment">* have made, use, import, offer to sell and sell (&quot;Utilize&quot;) this software subject to the</span>
<a name="l00012"></a>00012 <span class="comment">* terms herein.  With respect to the foregoing patent license, such license is granted</span>
<a name="l00013"></a>00013 <span class="comment">* solely to the extent that any such patent is necessary to Utilize the software alone.</span>
<a name="l00014"></a>00014 <span class="comment">* The patent license shall not apply to any combinations which include this software,</span>
<a name="l00015"></a>00015 <span class="comment">* other than combinations with devices manufactured by or for TI (&quot;TI Devices&quot;).</span>
<a name="l00016"></a>00016 <span class="comment">* No hardware patent is licensed hereunder.</span>
<a name="l00017"></a>00017 <span class="comment">*</span>
<a name="l00018"></a>00018 <span class="comment">* Redistributions must preserve existing copyright notices and reproduce this license</span>
<a name="l00019"></a>00019 <span class="comment">* (including the above copyright notice and the disclaimer and (if applicable) source</span>
<a name="l00020"></a>00020 <span class="comment">* code license limitations below) in the documentation and/or other materials provided</span>
<a name="l00021"></a>00021 <span class="comment">* with the distribution</span>
<a name="l00022"></a>00022 <span class="comment">*</span>
<a name="l00023"></a>00023 <span class="comment">* Redistribution and use in binary form, without modification, are permitted provided</span>
<a name="l00024"></a>00024 <span class="comment">* that the following conditions are met:</span>
<a name="l00025"></a>00025 <span class="comment">*</span>
<a name="l00026"></a>00026 <span class="comment">* *       No reverse engineering, decompilation, or disassembly of this software is</span>
<a name="l00027"></a>00027 <span class="comment">* permitted with respect to any software provided in binary form.</span>
<a name="l00028"></a>00028 <span class="comment">*</span>
<a name="l00029"></a>00029 <span class="comment">* *       any redistribution and use are licensed by TI for use only with TI Devices.</span>
<a name="l00030"></a>00030 <span class="comment">*</span>
<a name="l00031"></a>00031 <span class="comment">* *       Nothing shall obligate TI to provide you with source code for the software</span>
<a name="l00032"></a>00032 <span class="comment">* licensed and provided to you in object code.</span>
<a name="l00033"></a>00033 <span class="comment">*</span>
<a name="l00034"></a>00034 <span class="comment">* If software source code is provided to you, modification and redistribution of the</span>
<a name="l00035"></a>00035 <span class="comment">* source code are permitted provided that the following conditions are met:</span>
<a name="l00036"></a>00036 <span class="comment">*</span>
<a name="l00037"></a>00037 <span class="comment">* *       any redistribution and use of the source code, including any resulting derivative</span>
<a name="l00038"></a>00038 <span class="comment">* works, are licensed by TI for use only with TI Devices.</span>
<a name="l00039"></a>00039 <span class="comment">*</span>
<a name="l00040"></a>00040 <span class="comment">* *       any redistribution and use of any object code compiled from the source code</span>
<a name="l00041"></a>00041 <span class="comment">* and any resulting derivative works, are licensed by TI for use only with TI Devices.</span>
<a name="l00042"></a>00042 <span class="comment">*</span>
<a name="l00043"></a>00043 <span class="comment">* Neither the name of Texas Instruments Incorporated nor the names of its suppliers</span>
<a name="l00044"></a>00044 <span class="comment">*</span>
<a name="l00045"></a>00045 <span class="comment">* may be used to endorse or promote products derived from this software without</span>
<a name="l00046"></a>00046 <span class="comment">* specific prior written permission.</span>
<a name="l00047"></a>00047 <span class="comment">*</span>
<a name="l00048"></a>00048 <span class="comment">* DISCLAIMER.</span>
<a name="l00049"></a>00049 <span class="comment">*</span>
<a name="l00050"></a>00050 <span class="comment">* THIS SOFTWARE IS PROVIDED BY TI AND TI&apos;S LICENSORS &quot;AS IS&quot; AND ANY EXPRESS</span>
<a name="l00051"></a>00051 <span class="comment">* OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES</span>
<a name="l00052"></a>00052 <span class="comment">* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.</span>
<a name="l00053"></a>00053 <span class="comment">* IN NO EVENT SHALL TI AND TI&apos;S LICENSORS BE LIABLE FOR ANY DIRECT, INDIRECT,</span>
<a name="l00054"></a>00054 <span class="comment">* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,</span>
<a name="l00055"></a>00055 <span class="comment">* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span>
<a name="l00056"></a>00056 <span class="comment">* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY</span>
<a name="l00057"></a>00057 <span class="comment">* OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE</span>
<a name="l00058"></a>00058 <span class="comment">* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED</span>
<a name="l00059"></a>00059 <span class="comment">* OF THE POSSIBILITY OF SUCH DAMAGE.</span>
<a name="l00060"></a>00060 <span class="comment">*</span>
<a name="l00061"></a>00061 <span class="comment">*/</span>
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00093"></a>00093 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00094"></a>00094 <span class="preprocessor">#include &lt;VX/vx.h&gt;</span>
<a name="l00095"></a>00095 <span class="preprocessor">#include &lt;TI/tivx.h&gt;</span>
<a name="l00096"></a>00096 <span class="preprocessor">#include &lt;<a class="code" href="utility_8h.html">utility.h</a>&gt;</span>
<a name="l00097"></a>00097 
<a name="l00099"></a><a class="code" href="vx__tutorial__graph__image__gradients_8c.html#a8118656bb5a60090a1dbffa402168438">00099</a> <span class="preprocessor">#define IN_FILE_NAME         &quot;colors.bmp&quot;</span>
<a name="l00100"></a>00100 <span class="preprocessor"></span>
<a name="l00102"></a><a class="code" href="vx__tutorial__graph__image__gradients_8c.html#ac7b4da9c3d57efe0b9187f424dba9324">00102</a> <span class="preprocessor">#define PHASE_FILE_NAME      &quot;vx_tutorial_graph_image_gradients_phase_out.bmp&quot;</span>
<a name="l00103"></a>00103 <span class="preprocessor"></span>
<a name="l00105"></a><a class="code" href="vx__tutorial__graph__image__gradients_8c.html#a477612b28de7f3778ec98290da147134">00105</a> <span class="preprocessor">#define MAGNITUDE_FILE_NAME  &quot;vx_tutorial_graph_image_gradients_magnitude_out.bmp&quot;</span>
<a name="l00106"></a>00106 <span class="preprocessor"></span>
<a name="l00108"></a><a class="code" href="vx__tutorial__graph__image__gradients_8c.html#a27e19862e6e875abe96f110243d1b5aa">00108</a> <span class="preprocessor">#define GRAD_X_FILE_NAME     &quot;vx_tutorial_graph_image_gradients_grad_x_out.bmp&quot;</span>
<a name="l00109"></a>00109 <span class="preprocessor"></span>
<a name="l00111"></a><a class="code" href="vx__tutorial__graph__image__gradients_8c.html#a6cd9df238bd8ee63bbaa4199395a09da">00111</a> <span class="preprocessor">#define GRAD_Y_FILE_NAME     &quot;vx_tutorial_graph_image_gradients_grad_y_out.bmp&quot;</span>
<a name="l00112"></a>00112 <span class="preprocessor"></span>
<a name="l00113"></a><a class="code" href="vx__tutorial__graph__image__gradients_8c.html#a196d5a36c4126bfa58ee4ea50baaae39">00113</a> <span class="preprocessor">#define NUM_NODES    (6u)</span>
<a name="l00114"></a>00114 <span class="preprocessor"></span>
<a name="l00118"></a><a class="code" href="vx__tutorial__graph__image__gradients_8c.html#a838f2ff5f2c2496ad0fee70c0c93f2b6">00118</a> <span class="keywordtype">void</span> <a class="code" href="vx__tutorial__graph__image__gradients_8c.html#a838f2ff5f2c2496ad0fee70c0c93f2b6" title="Tutorial Entry Point.">vx_tutorial_graph_image_gradients</a>()
<a name="l00119"></a>00119 {
<a name="l00127"></a>00127     vx_context context;
<a name="l00128"></a>00128     vx_image in_image = NULL;
<a name="l00129"></a>00129     vx_image grad_x = NULL;
<a name="l00130"></a>00130     vx_image grad_y = NULL;
<a name="l00131"></a>00131     vx_image magnitude = NULL;
<a name="l00132"></a>00132     vx_image phase = NULL;
<a name="l00133"></a>00133     vx_image magnitude_image = NULL;
<a name="l00134"></a>00134     vx_image grad_x_image = NULL;
<a name="l00135"></a>00135     vx_image grad_y_image = NULL;
<a name="l00136"></a>00136     vx_graph graph = NULL;
<a name="l00137"></a>00137     vx_scalar shift = NULL;
<a name="l00138"></a>00138     vx_node node[<a class="code" href="vx__tutorial__graph__image__gradients_8c.html#a196d5a36c4126bfa58ee4ea50baaae39">NUM_NODES</a>] = {NULL};
<a name="l00140"></a>00140     int32_t shift_value = 0;
<a name="l00141"></a>00141     vx_uint32 width, height;
<a name="l00142"></a>00142     vx_status status;
<a name="l00143"></a>00143     uint32_t i;
<a name="l00144"></a>00144 
<a name="l00145"></a>00145     printf(<span class="stringliteral">&quot; vx_tutorial_graph_image_gradients: Tutorial Started !!! \n&quot;</span>);
<a name="l00146"></a>00146 
<a name="l00154"></a>00154     context = vxCreateContext();
<a name="l00157"></a>00157     printf(<span class="stringliteral">&quot; Loading file %s ...\n&quot;</span>, <a class="code" href="vx__tutorial__image__load__save_8c.html#a8118656bb5a60090a1dbffa402168438" title="Input file name.">IN_FILE_NAME</a>);
<a name="l00158"></a>00158 
<a name="l00166"></a>00166     in_image = <a class="code" href="utility_8h.html#af8e9cbbd49ab0dec7850267224548cd6" title="Create a image data object given BMP filename as input.">create_image_from_file</a>(context, <a class="code" href="vx__tutorial__image__load__save_8c.html#a8118656bb5a60090a1dbffa402168438" title="Input file name.">IN_FILE_NAME</a>, vx_true_e);
<a name="l00169"></a>00169     vxSetReferenceName((vx_reference)in_image, <span class="stringliteral">&quot;INPUT&quot;</span>);
<a name="l00170"></a>00170 
<a name="l00178"></a>00178     <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(in_image);
<a name="l00181"></a>00181     vxQueryImage(in_image, VX_IMAGE_WIDTH, &amp;width, <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00182"></a>00182     vxQueryImage(in_image, VX_IMAGE_HEIGHT, &amp;height, <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00183"></a>00183 
<a name="l00191"></a>00191     grad_x = vxCreateImage(context, width, height, VX_DF_IMAGE_S16);
<a name="l00194"></a>00194     vxSetReferenceName((vx_reference)grad_x, <span class="stringliteral">&quot;GRAD_X&quot;</span>);
<a name="l00195"></a>00195 
<a name="l00203"></a>00203     <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(grad_x);
<a name="l00213"></a>00213     grad_y = vxCreateImage(context, width, height, VX_DF_IMAGE_S16);
<a name="l00216"></a>00216     vxSetReferenceName((vx_reference)grad_y, <span class="stringliteral">&quot;GRAD_Y&quot;</span>);
<a name="l00217"></a>00217 
<a name="l00225"></a>00225     <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(grad_y);
<a name="l00235"></a>00235     magnitude = vxCreateImage(context, width, height, VX_DF_IMAGE_S16);
<a name="l00238"></a>00238     vxSetReferenceName((vx_reference)magnitude, <span class="stringliteral">&quot;MAGNITUDE&quot;</span>);
<a name="l00239"></a>00239 
<a name="l00247"></a>00247     <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(magnitude);
<a name="l00257"></a>00257     magnitude_image = vxCreateImage(context, width, height, VX_DF_IMAGE_U8);
<a name="l00260"></a>00260     vxSetReferenceName((vx_reference)magnitude_image, <span class="stringliteral">&quot;MAGNITUDE_IMAGE&quot;</span>);
<a name="l00261"></a>00261 
<a name="l00269"></a>00269     <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(magnitude_image);
<a name="l00279"></a>00279     grad_x_image = vxCreateImage(context, width, height, VX_DF_IMAGE_U8);
<a name="l00282"></a>00282     vxSetReferenceName((vx_reference)grad_x_image, <span class="stringliteral">&quot;GRAD_X_IMAGE&quot;</span>);
<a name="l00283"></a>00283 
<a name="l00291"></a>00291     <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(grad_x_image);
<a name="l00301"></a>00301     grad_y_image = vxCreateImage(context, width, height, VX_DF_IMAGE_U8);
<a name="l00304"></a>00304     vxSetReferenceName((vx_reference)grad_y_image, <span class="stringliteral">&quot;GRAD_Y_IMAGE&quot;</span>);
<a name="l00305"></a>00305 
<a name="l00313"></a>00313     <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(grad_y_image);
<a name="l00316"></a>00316     shift = vxCreateScalar(context, VX_TYPE_INT32, &amp;shift_value);
<a name="l00317"></a>00317 
<a name="l00325"></a>00325     phase = vxCreateImage(context, width, height, VX_DF_IMAGE_U8);
<a name="l00327"></a>00327     vxSetReferenceName((vx_reference)phase, <span class="stringliteral">&quot;PHASE&quot;</span>);
<a name="l00328"></a>00328 
<a name="l00336"></a>00336     <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(phase);
<a name="l00344"></a>00344     graph = vxCreateGraph(context);
<a name="l00346"></a>00346     i = 0;
<a name="l00347"></a>00347 
<a name="l00356"></a>00356     node[i] = vxSobel3x3Node(graph, in_image, grad_x, grad_y);
<a name="l00359"></a>00359     vxSetReferenceName((vx_reference)node[i], <span class="stringliteral">&quot;SOBEL3x3&quot;</span>);
<a name="l00360"></a>00360 
<a name="l00367"></a>00367     vxSetNodeTarget(node[i], VX_TARGET_STRING, TIVX_TARGET_DSP1);
<a name="l00369"></a>00369     i++;
<a name="l00370"></a>00370 
<a name="l00379"></a>00379     node[i] = vxMagnitudeNode(graph, grad_x, grad_y, magnitude);
<a name="l00382"></a>00382     vxSetReferenceName((vx_reference)node[i], <span class="stringliteral">&quot;MAGNITUDE&quot;</span>);
<a name="l00383"></a>00383 
<a name="l00390"></a>00390     vxSetNodeTarget(node[i], VX_TARGET_STRING, TIVX_TARGET_DSP1);
<a name="l00392"></a>00392     i++;
<a name="l00393"></a>00393 
<a name="l00402"></a>00402     node[i] = vxPhaseNode(graph, grad_x, grad_y, phase);
<a name="l00405"></a>00405     vxSetReferenceName((vx_reference)node[i], <span class="stringliteral">&quot;PHASE&quot;</span>);
<a name="l00412"></a>00412     vxSetNodeTarget(node[i], VX_TARGET_STRING, TIVX_TARGET_DSP2);
<a name="l00414"></a>00414     i++;
<a name="l00415"></a>00415 
<a name="l00425"></a>00425     node[i] = vxConvertDepthNode(graph,
<a name="l00426"></a>00426                     magnitude, magnitude_image,
<a name="l00427"></a>00427                     VX_CONVERT_POLICY_SATURATE,
<a name="l00428"></a>00428                     shift);
<a name="l00431"></a>00431     vxSetReferenceName((vx_reference)node[i], <span class="stringliteral">&quot;MAGNITUDE_IMAGE&quot;</span>);
<a name="l00432"></a>00432 
<a name="l00439"></a>00439     vxSetNodeTarget(node[i], VX_TARGET_STRING, TIVX_TARGET_DSP1);
<a name="l00442"></a>00442     i++;
<a name="l00443"></a>00443 
<a name="l00453"></a>00453     node[i] = vxConvertDepthNode(graph,
<a name="l00454"></a>00454                     grad_x, grad_x_image,
<a name="l00455"></a>00455                     VX_CONVERT_POLICY_SATURATE,
<a name="l00456"></a>00456                     shift);
<a name="l00459"></a>00459     vxSetReferenceName((vx_reference)node[i], <span class="stringliteral">&quot;GRAD_X_IMAGE&quot;</span>);
<a name="l00460"></a>00460 
<a name="l00467"></a>00467     vxSetNodeTarget(node[i], VX_TARGET_STRING, TIVX_TARGET_DSP1);
<a name="l00470"></a>00470     i++;
<a name="l00471"></a>00471 
<a name="l00481"></a>00481     node[i] = vxConvertDepthNode(graph,
<a name="l00482"></a>00482                     grad_y, grad_y_image,
<a name="l00483"></a>00483                     VX_CONVERT_POLICY_SATURATE,
<a name="l00484"></a>00484                     shift);
<a name="l00485"></a>00485     vxSetReferenceName((vx_reference)node[i], <span class="stringliteral">&quot;GRAD_Y_IMAGE&quot;</span>);
<a name="l00486"></a>00486 
<a name="l00493"></a>00493     vxSetNodeTarget(node[i], VX_TARGET_STRING, TIVX_TARGET_DSP2);
<a name="l00496"></a>00496     i++;
<a name="l00497"></a>00497 
<a name="l00505"></a>00505     status = vxVerifyGraph(graph);
<a name="l00515"></a>00515     <a class="code" href="utility_8h.html#a86ae0d04d187710cc2d10f85bccb6e5d" title="Show attributes of previously created graph.">show_graph_attributes</a>(graph);
<a name="l00518"></a>00518     <span class="keywordflow">for</span>(i=0; i&lt;<span class="keyword">sizeof</span>(node)/<span class="keyword">sizeof</span>(node[0]); i++)
<a name="l00519"></a>00519     {
<a name="l00520"></a>00520         <span class="keywordflow">if</span>(node[i])
<a name="l00521"></a>00521         {
<a name="l00529"></a>00529             <a class="code" href="utility_8h.html#a4576aae15198e9645228f21be4290cff" title="Show attributes of previously created node.">show_node_attributes</a>(node[i]);
<a name="l00531"></a>00531         }
<a name="l00532"></a>00532     }
<a name="l00533"></a>00533 
<a name="l00534"></a>00534     <span class="keywordflow">if</span>(status==VX_SUCCESS)
<a name="l00535"></a>00535     {
<a name="l00536"></a>00536         printf(<span class="stringliteral">&quot; Executing graph ...\n&quot;</span>);
<a name="l00537"></a>00537 
<a name="l00546"></a>00546         vxScheduleGraph(graph);
<a name="l00555"></a>00555         vxWaitGraph(graph);
<a name="l00558"></a>00558         printf(<span class="stringliteral">&quot; Executing graph ... Done !!!\n&quot;</span>);
<a name="l00559"></a>00559 
<a name="l00567"></a>00567         <a class="code" href="utility_8h.html#a86ae0d04d187710cc2d10f85bccb6e5d" title="Show attributes of previously created graph.">show_graph_attributes</a>(graph);
<a name="l00569"></a>00569         <span class="keywordflow">for</span>(i=0; i&lt;<span class="keyword">sizeof</span>(node)/<span class="keyword">sizeof</span>(node[0]); i++)
<a name="l00570"></a>00570         {
<a name="l00571"></a>00571             <span class="keywordflow">if</span>(node[i])
<a name="l00572"></a>00572             {
<a name="l00580"></a>00580                 <a class="code" href="utility_8h.html#a4576aae15198e9645228f21be4290cff" title="Show attributes of previously created node.">show_node_attributes</a>(node[i]);
<a name="l00582"></a>00582             }
<a name="l00583"></a>00583         }
<a name="l00584"></a>00584 
<a name="l00585"></a>00585         printf(<span class="stringliteral">&quot; Saving to file %s ...\n&quot;</span>, <a class="code" href="vx__tutorial__graph__image__gradients_8c.html#ac7b4da9c3d57efe0b9187f424dba9324" title="Phase file name.">PHASE_FILE_NAME</a>);
<a name="l00594"></a>00594         <a class="code" href="utility_8h.html#a2ffb77a8e510c0236b07306d0eb47a30" title="Save data from image object to BMP file.">save_image_to_file</a>(<a class="code" href="vx__tutorial__graph__image__gradients_8c.html#ac7b4da9c3d57efe0b9187f424dba9324" title="Phase file name.">PHASE_FILE_NAME</a>, phase);
<a name="l00597"></a>00597         printf(<span class="stringliteral">&quot; Saving to file %s ...\n&quot;</span>, <a class="code" href="vx__tutorial__graph__image__gradients_8c.html#a477612b28de7f3778ec98290da147134" title="Magnitude file name.">MAGNITUDE_FILE_NAME</a>);
<a name="l00606"></a>00606         <a class="code" href="utility_8h.html#a2ffb77a8e510c0236b07306d0eb47a30" title="Save data from image object to BMP file.">save_image_to_file</a>(<a class="code" href="vx__tutorial__graph__image__gradients_8c.html#a477612b28de7f3778ec98290da147134" title="Magnitude file name.">MAGNITUDE_FILE_NAME</a>, magnitude_image);
<a name="l00609"></a>00609         printf(<span class="stringliteral">&quot; Saving to file %s ...\n&quot;</span>, <a class="code" href="vx__tutorial__graph__image__gradients_8c.html#a27e19862e6e875abe96f110243d1b5aa" title="Gradient X file name.">GRAD_X_FILE_NAME</a>);
<a name="l00618"></a>00618         <a class="code" href="utility_8h.html#a2ffb77a8e510c0236b07306d0eb47a30" title="Save data from image object to BMP file.">save_image_to_file</a>(<a class="code" href="vx__tutorial__graph__image__gradients_8c.html#a27e19862e6e875abe96f110243d1b5aa" title="Gradient X file name.">GRAD_X_FILE_NAME</a>, grad_x_image);
<a name="l00621"></a>00621         printf(<span class="stringliteral">&quot; Saving to file %s ...\n&quot;</span>, <a class="code" href="vx__tutorial__graph__image__gradients_8c.html#a6cd9df238bd8ee63bbaa4199395a09da" title="Gradient Y file name.">GRAD_Y_FILE_NAME</a>);
<a name="l00630"></a>00630         <a class="code" href="utility_8h.html#a2ffb77a8e510c0236b07306d0eb47a30" title="Save data from image object to BMP file.">save_image_to_file</a>(<a class="code" href="vx__tutorial__graph__image__gradients_8c.html#a6cd9df238bd8ee63bbaa4199395a09da" title="Gradient Y file name.">GRAD_Y_FILE_NAME</a>, grad_y_image);
<a name="l00632"></a>00632     }
<a name="l00633"></a>00633 
<a name="l00640"></a>00640     vxReleaseImage(&amp;in_image);
<a name="l00641"></a>00641     vxReleaseImage(&amp;grad_x);
<a name="l00642"></a>00642     vxReleaseImage(&amp;grad_y);
<a name="l00643"></a>00643     vxReleaseImage(&amp;grad_x_image);
<a name="l00644"></a>00644     vxReleaseImage(&amp;grad_y_image);
<a name="l00645"></a>00645     vxReleaseImage(&amp;phase);
<a name="l00646"></a>00646     vxReleaseImage(&amp;magnitude);
<a name="l00647"></a>00647     vxReleaseImage(&amp;magnitude_image);
<a name="l00656"></a>00656     vxReleaseScalar(&amp;shift);
<a name="l00659"></a>00659     <span class="keywordflow">for</span>(i=0; i&lt;<span class="keyword">sizeof</span>(node)/<span class="keyword">sizeof</span>(node[0]); i++)
<a name="l00660"></a>00660     {
<a name="l00661"></a>00661         <span class="keywordflow">if</span>(node[i])
<a name="l00662"></a>00662         {
<a name="l00669"></a>00669             vxReleaseNode(&amp;node[i]);
<a name="l00671"></a>00671         }
<a name="l00672"></a>00672     }
<a name="l00673"></a>00673 
<a name="l00680"></a>00680     vxReleaseGraph(&amp;graph);
<a name="l00691"></a>00691     vxReleaseContext(&amp;context);
<a name="l00694"></a>00694     printf(<span class="stringliteral">&quot; vx_tutorial_graph_image_gradients: Tutorial Done !!! \n&quot;</span>);
<a name="l00695"></a>00695     printf(<span class="stringliteral">&quot; \n&quot;</span>);
<a name="l00696"></a>00696 }
</pre></div></div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
